# SPDX-FileCopyrightText: 2024 The eminus developers
# SPDX-License-Identifier: Apache-2.0
from collections.abc import Callable
from logging import Formatter, Logger, LogRecord
from typing import Any

class CustomLogger(Logger):
    def __init__(self, name: str) -> None: ...
    @property
    def verbose(self) -> str: ...
    @verbose.setter
    def verbose(self, level: int | str) -> None: ...

class CustomFormatter(Formatter):
    def format(self, record: LogRecord) -> str: ...

def create_logger(obj: object) -> CustomLogger: ...
def get_level(verbose: int | str | None) -> str: ...
def name(newname: str) -> Callable[..., Any]: ...

log: CustomLogger
